#include <cstdlib>
#include <stddef.h>
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <string.h>
#include <omp.h>

#include "ParticionaNumero.h"
#include "/home/marcelo/NetBeansProjects/Biblioteca/Arquivo.h"


using namespace std;

void Ordena(string *vetInstancias, int *vetTam, int n){
 
    int j,i, aux;
    string key;
    for(j = 1; j <= n; j++){
        key = vetInstancias[j];
        aux = vetTam[j];
        i = j - 1;
        while(i > (-1) && vetInstancias[i] > key){
            vetInstancias[i + 1] = vetInstancias[i];
            vetTam[i + 1] = vetTam[i];
            i = i - 1;
        }
        vetInstancias[i + 1] = key; 
        vetTam[i + 1] = aux;
    }
}


void ImprimeMenuConstrucao(int &opcao){
    
    cout << "----------------------Menu------------------------" << endl;
    cout << "1 - Construcao Gulosa" << endl;
    cout << "2 - Construcao Aleatoria" << endl;
    cout << "0 - Sair" << endl;
    cout << "-------------------------------------------------" << endl;
    
    cout << "Digite uma opção: ";
    scanf("%d", &opcao);
}

void ImprimeMenu(int &opcao){
    
    cout << "----------------------Menu------------------------" << endl;

    cout << "1 - Construcao Gulosa" << endl;
    cout << "2 - Construcao Aleatoria" << endl;
    cout << "-------------------------------------------------" << endl;
    cout << "3 - Best Improvement" << endl;
    cout << "4 - First Improvement" << endl;
    cout << "5 - Randon Improvement" << endl;
    cout << "6 - MultiStart" << endl;
    cout << "7 - Busca Tabu" << endl;
    cout << "8 - Grasp" << endl;
    cout << "9 - Simulated Annealing" << endl;
    cout << "0 - Sair" << endl;
    cout << "-------------------------------------------------" << endl;
    
    cout << "Digite uma opção: ";
    scanf("%d", &opcao);
}


const char *EscolhaInstancia(int &tamanho){
    
    DIR *dp;
    struct dirent *ep;
    
    int i = 0, j;
    int op;
    string tam;
    
    char s;
    
    string vetInstancias[40];
    int vetTam[40];

    dp = opendir ("./Instancias");
    if (dp != NULL)
    {
        while (ep = readdir(dp)){
            if(strlen(ep->d_name)>2){
                i++;
                //cout << i  << " - "<< ep->d_name << endl;
                vetInstancias[i] = "Instancias/";
                vetInstancias[i] += ep->d_name;
                
                /*Instancias/Particao-XXX-X.txt vigesima posicao da string*/
                j=20;
                s = vetInstancias[i][j];
                while(s != '-'){
                    tam += s;
                    j++;
                    s = vetInstancias[i][j];
                }
                vetTam[i] = atoi(tam.c_str());
                tam.clear();
            }
        }
        closedir (dp);
    }
    else{
        cout << "Nao foi possivel abrir o diretorio" << endl;
        exit(1);
    }
    
    Ordena(vetInstancias, vetTam,i);
    
    for (j=1; j < i; j++) {
        cout << j  << " -\t"<< vetInstancias[j] << /*"\tTam: " << vetTam[j] <<*/ endl;
    }


    
    cout << endl << "===========================" << endl;
    
    cout << "Escolha uma instancia: ";
    scanf("%d", &op);
    
    if(op<1){
        cout << "Opcao invalida" << endl;
        exit(1);
    }

    cout << endl << "Instancia selecionada: " << vetInstancias[op] << " Tamanho : " << vetTam[op] << endl << endl;
    tamanho = vetTam[op];
    return vetInstancias[op].c_str();
    
}


int main(int argc, char** argv) {

    int tamanho, numeroParticao;

    int opcao;
    const char *instancia;

    instancia = EscolhaInstancia(tamanho);

    cout << "Digite quantas partições deseja: ";
    scanf("%d", &numeroParticao);
    
    
    
    //int *vet;
    //vet = (int *)malloc(tamanho *sizeof(int));
    int vet[tamanho];
    
    LeArquivoInstanciaParticaoNumero(instancia, vet);
    

    ConjuntoNumeros l(tamanho);
    
    /*Seta o vetor lido no arquivo para a TAD criada*/
    l.GeraListaVetor(vet, tamanho);
    l.SetNumParticao(numeroParticao);

    system("clear");
    
    do{
        ImprimeMenuConstrucao(opcao);
    }while(opcao<0 || opcao>2);
    
    if(opcao == 0){
        exit(0);
    }
    
    /*Imprime a opcao da construcao da solucao*/
    ParticionaNumero(l, numeroParticao, opcao, tamanho);
    cout << "Pressione [Enter] para continuar...";
    getchar();
    getchar();
    system("clear");

    while(opcao > 0){
        //if(opcao > 2){
            ParticionaNumero(l, numeroParticao, opcao, tamanho);
            cout << "Pressione [Enter] para continuar...";
            getchar();
            getchar();
            system("clear");
        //}
        ImprimeMenu(opcao);
        
    }
    
    return 0;
}
